Imports System.Text
Imports System.Net
Imports System.Net.Sockets
Imports System.Threading

Public Class clsTxRxData

#Region " Public Structures "

    Public Structure UDPInfo
        Dim IP As String
        Dim Message As String
        Dim Port As Integer
    End Structure

#End Region

#Region " Public Events "

    Public Event DataRcvd(ByVal Data As UDPInfo)

#End Region

#Region " Private Variables "

    Private UDPClient As New UdpClient
    Private RcvPoint As IPEndPoint
    Private ReadThread As Thread = New Thread(New ThreadStart(AddressOf WaitForPacket))

#End Region

#Region " Private Subs & Functions "

    Private Sub WaitForPacket()

        Dim Data() As Byte
        Dim Info As New UDPInfo
        Do
            Data = UDPClient.Receive(RcvPoint)
            If Data.Length > 0 Then
                Info.Message = System.Text.Encoding.ASCII.GetString(Data)
                Info.IP = RcvPoint.Address.ToString
                Info.Port = RcvPoint.Port
                RaiseEvent DataRcvd(Info)
            End If
        Loop


    End Sub

#End Region

#Region " Public Subs & Functions "

    Public Sub RX(ByVal Port As Integer)

        UDPClient = New UdpClient(Port)
        RcvPoint = New IPEndPoint(New IPAddress(0), 0)
        ReadThread = New Thread(New ThreadStart(AddressOf WaitForPacket))
        ReadThread.Start()

    End Sub

    Public Sub TX(ByVal Data As UDPInfo)

        Thread.Sleep(200)
        Dim Encoding As New System.Text.ASCIIEncoding
        Dim Message() As Byte = Encoding.GetBytes(Data.Message)
        UDPClient.Send(Message, Message.Length, Data.IP, Data.Port)

    End Sub

    Public Sub Close()

        ReadThread.Abort()
        ReadThread = Nothing
        UDPClient.Close()
        UDPClient = Nothing

    End Sub

#End Region

End Class
